### Method

# EDataBook BookMetaBackend search_sync

since: 3.26

#### Declaration [src]

    gboolean
    e_book_meta_backend_search_sync (
      EBookMetaBackend* meta_backend,
      const gchar* expr,
      gboolean meta_contact,
      GSList** out_contacts,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Searches `meta_backend` with given expression `expr` and returns found contacts as a `GSList` of `EContact` `out_contacts`. Free the returned `out_contacts` with g_slist_free_full (contacts, g_object_unref); when no longer needed. When the `expr` is `NULL`, all objects are returned. To get UID-s instead, call e_book_meta_backend_search_uids_sync().

It is optional to implement this virtual method by the descendant. The default implementation searches `meta_backend`‘s cache. It’s also not required to be online for searching, thus `meta_backend` doesn’t ensure it.

Available since: 3.26

#### Parameters

`expr`

  Type: `const gchar*`

  A search expression, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`meta_contact`

  Type: `gboolean`

  `TRUE`, when return `EContact` filled with UID and REV only, `FALSE` to return full contacts.

`out_contacts`

  Type: A list of `EContact*`

  Return location for the found contacts as `EContact`.

  The argument will be set by the function.
  The caller of the method takes ownership of the returned data, and is responsible for freeing it.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

Whether succeeded.